Object subclass: #Celda
	instanceVariableNames: 'valor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Planilla'!


!Celda methodsFor: 'accessing' stamp: 'a 9/12/2019 18:05'!
initialize
	valor := ''.

! !

!Celda methodsFor: 'accessing' stamp: 'a 9/12/2019 18:05'!
getValor
	^ valor.
! !


!Celda methodsFor: 'as yet unclassified' stamp: 'a 9/13/2019 15:42'!
estaVacia
	^ valor = ''.! !

!Celda methodsFor: 'as yet unclassified' stamp: 'a 9/12/2019 18:06'!
setValor: unValor 
	valor := unValor.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Celda class
	instanceVariableNames: ''!

!Celda class methodsFor: 'as yet unclassified' stamp: 'a 9/12/2019 17:01'!
conUbicacion: unaUbicacion
	| celda |
	celda := Celda new.
	celda setUbicacion: unaUbicacion.
	^ celda.	
	! !


Object subclass: #DireccionHorizontal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Planilla'!

!DireccionHorizontal methodsFor: 'as yet unclassified' stamp: 'a 9/13/2019 15:40'!
siguienteA: unaUbicacion
	^ Ubicacion conFila: (unaUbicacion fila) yColumna: (unaUbicacion columna + 1).
! !


Object subclass: #Planilla
	instanceVariableNames: 'dicCelda'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Planilla'!

!Planilla methodsFor: 'as yet unclassified' stamp: 'a 9/13/2019 15:13'!
colocarEnCelda: unaCoordenada elValor: unValor
	|celda|
	celda := self getCelda: (Ubicacion con: unaCoordenada).
	celda setValor: unValor.
	! !

!Planilla methodsFor: 'as yet unclassified' stamp: 'a 9/13/2019 15:14'!
crearRangoHorizontalDesde: unaCoordenada hasta: otraCoordenada
	^ RangoHorizontal conPrincipioEn: (Ubicacion con: unaCoordenada) yFinEn: (Ubicacion con: otraCoordenada) enPlanilla: self.
! !

!Planilla methodsFor: 'as yet unclassified' stamp: 'a 9/12/2019 18:03'!
getCelda: unaUbicacion
	|celda|
	celda := dicCelda at: unaUbicacion ifAbsentPut: [Celda new].
	^ celda.
	! !

!Planilla methodsFor: 'as yet unclassified' stamp: 'a 9/13/2019 15:15'!
getValorEnCelda: unaCoordenada
	|celda| 
	celda := self getCelda: (Ubicacion con: unaCoordenada).
	^ celda getValor.
	! !


!Planilla methodsFor: 'initialization' stamp: 'a 9/12/2019 18:00'!
initialize
	dicCelda := Dictionary new.
! !


Object subclass: #RangoHorizontal
	instanceVariableNames: 'desde hasta planilla'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Planilla'!

!RangoHorizontal methodsFor: 'initialization' stamp: 'a 9/13/2019 15:59'!
getCantidadCeldasUsadas
	|unaCantidad |
	unaCantidad := 0.
	self celdasDo: [ :unaCelda | 
		(unaCelda estaVacia) ifFalse: [ unaCantidad := unaCantidad + 1 ].
		].
	^ unaCantidad.
! !

!RangoHorizontal methodsFor: 'initialization' stamp: 'a 9/12/2019 18:44'!
setDesde: unaUbicacion yHasta: otraUbicacion yPlanilla: unaPlanilla
	desde := unaUbicacion.
	hasta := otraUbicacion.
	planilla := unaPlanilla.
! !

!RangoHorizontal methodsFor: 'initialization' stamp: 'a 9/13/2019 15:58'!
celdasDo: unBloqueCodigo
	| unaCelda |
	(desde ubicacionesHasta: hasta enDireccion: (DireccionHorizontal new)) do: [ :unaUbicacion | 
		unaCelda := (planilla getCelda: unaUbicacion).
		unBloqueCodigo value: unaCelda.
		].
! !

!RangoHorizontal methodsFor: 'initialization' stamp: 'a 9/13/2019 16:12'!
getSuma
	|unaSuma |
	unaSuma := 0.
	self celdasDo: [ :unaCelda | 
		(unaCelda estaVacia) ifFalse: [ 
			unaCelda getValor isNumber ifTrue: [ unaSuma := unaSuma + (unaCelda getValor)  ].
			 ].
		].
	^ unaSuma.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

RangoHorizontal class
	instanceVariableNames: ''!

!RangoHorizontal class methodsFor: 'as yet unclassified' stamp: 'a 9/12/2019 18:26'!
conPrincipioEn: unaUbicacion yFinEn: otraUbicacion enPlanilla: unaPlanilla
	|unRango|
	unRango := RangoHorizontal new.
	unRango setDesde: unaUbicacion yHasta: otraUbicacion yPlanilla: unaPlanilla.
	^ unRango.
! !


Object subclass: #Ubicacion
	instanceVariableNames: 'fila columna'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Planilla'!

!Ubicacion methodsFor: 'initialization' stamp: 'a 9/13/2019 15:12'!
hash
	^ fila + columna.

	! !

!Ubicacion methodsFor: 'initialization' stamp: 'a 9/13/2019 15:03'!
setFila: unaFila
	fila := unaFila.
	! !

!Ubicacion methodsFor: 'initialization' stamp: 'a 9/13/2019 15:17'!
fila
	^ fila.

	! !

!Ubicacion methodsFor: 'initialization' stamp: 'a 9/13/2019 15:17'!
columna
	^ columna.


	! !

!Ubicacion methodsFor: 'initialization' stamp: 'a 9/13/2019 15:04'!
= otraUbicacion
	^ (self coordenada) = (otraUbicacion coordenada).
	! !

!Ubicacion methodsFor: 'initialization' stamp: 'a 9/13/2019 15:39'!
ubicacionesHasta: otraUbicacion enDireccion: unaDireccion
	| listaUbicaciones ubicacionActual |
	listaUbicaciones := OrderedCollection new.
	ubicacionActual := self.
	listaUbicaciones add: ubicacionActual.
	[ ubicacionActual ~= otraUbicacion ] whileTrue: [ 
		ubicacionActual := unaDireccion siguienteA: ubicacionActual.
		listaUbicaciones add: ubicacionActual.
	 ].
	^ listaUbicaciones.
	! !

!Ubicacion methodsFor: 'initialization' stamp: 'a 9/13/2019 14:59'!
coordenada
	^ (String value: ($A asciiValue + columna)) , (String value: ($1 asciiValue + fila)).

	! !

!Ubicacion methodsFor: 'initialization' stamp: 'a 9/13/2019 15:03'!
setColumna: unaColumna
	columna := unaColumna.
	! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Ubicacion class
	instanceVariableNames: ''!

!Ubicacion class methodsFor: 'as yet unclassified' stamp: 'a 9/13/2019 15:02'!
con: unaCoordenada
	| unaUbicacion |
	unaUbicacion := Ubicacion new.
	unaUbicacion setColumna: ((unaCoordenada at: 1) asciiValue) - ($A asciiValue).
	unaUbicacion setFila: ((unaCoordenada at: 2) asciiValue) - ($1 asciiValue).
	^ unaUbicacion.! !

!Ubicacion class methodsFor: 'as yet unclassified' stamp: 'a 9/13/2019 15:21'!
conFila: unaFila yColumna: unaColumna
	| unaUbicacion |
	unaUbicacion := Ubicacion new.
	unaUbicacion setColumna: unaColumna.
	unaUbicacion setFila: unaFila.
	^ unaUbicacion.! !
