Object subclass: #Celda
	instanceVariableNames: 'valor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Planilla'!


!Celda methodsFor: 'accessing' stamp: 'a 9/12/2019 18:05'!
initialize
	valor := ''.

! !

!Celda methodsFor: 'accessing' stamp: 'a 9/12/2019 18:05'!
getValor
	^ valor.
! !


!Celda methodsFor: 'as yet unclassified' stamp: 'a 9/12/2019 18:06'!
setValor: unValor 
	valor := unValor.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Celda class
	instanceVariableNames: ''!

!Celda class methodsFor: 'as yet unclassified' stamp: 'a 9/12/2019 17:01'!
conUbicacion: unaUbicacion
	| celda |
	celda := Celda new.
	celda setUbicacion: unaUbicacion.
	^ celda.	
	! !


Object subclass: #Planilla
	instanceVariableNames: 'dicCelda'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Planilla'!

!Planilla methodsFor: 'as yet unclassified' stamp: 'a 9/12/2019 18:06'!
colocarEnCelda: unaUbicacion elValor: unValor
	|celda|
	celda := self getCelda: unaUbicacion.
	celda setValor: unValor.
	! !

!Planilla methodsFor: 'as yet unclassified' stamp: 'a 9/12/2019 18:20'!
crearRangoHorizontalDesde: unaUbicacion hasta: otraUbicacion
	^ RangoHorizontal conPrincipioEn: unaUbicacion yFinEn: otraUbicacion enPlanilla: self.
! !

!Planilla methodsFor: 'as yet unclassified' stamp: 'a 9/12/2019 18:03'!
getCelda: unaUbicacion
	|celda|
	celda := dicCelda at: unaUbicacion ifAbsentPut: [Celda new].
	^ celda.
	! !

!Planilla methodsFor: 'as yet unclassified' stamp: 'a 9/12/2019 17:45'!
getValorEnCelda: unaUbicacion
	|celda| 
	celda := self getCelda: unaUbicacion.
	^ celda getValor.
	! !


!Planilla methodsFor: 'initialization' stamp: 'a 9/12/2019 18:00'!
initialize
	dicCelda := Dictionary new.
! !


Object subclass: #RangoHorizontal
	instanceVariableNames: 'desde hasta planilla'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Planilla'!

!RangoHorizontal methodsFor: 'initialization' stamp: 'a 9/12/2019 18:58'!
getCantidadCeldasUsadas
	|unaFila unaColumnaInicial unaColumnaFinal unaCantidad unaCelda|
	unaCantidad := 0.
	unaFila := (desde at: 2).
	unaColumnaInicial := (desde at: 1).
	unaColumnaFinal := (hasta at: 1).
	(unaColumnaInicial to: unaColumnaFinal) do: [ :unaColumna | 
		unaCelda := (planilla getCelda: (unaColumna asString ,unaFila asString )).
		(unaCelda getValor = '') ifFalse: [ unaCantidad := unaCantidad + 1 ].
		].
	^ unaCantidad.
! !

!RangoHorizontal methodsFor: 'initialization' stamp: 'a 9/12/2019 18:44'!
setDesde: unaUbicacion yHasta: otraUbicacion yPlanilla: unaPlanilla
	desde := unaUbicacion.
	hasta := otraUbicacion.
	planilla := unaPlanilla.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

RangoHorizontal class
	instanceVariableNames: ''!

!RangoHorizontal class methodsFor: 'as yet unclassified' stamp: 'a 9/12/2019 18:26'!
conPrincipioEn: unaUbicacion yFinEn: otraUbicacion enPlanilla: unaPlanilla
	|unRango|
	unRango := RangoHorizontal new.
	unRango setDesde: unaUbicacion yHasta: otraUbicacion yPlanilla: unaPlanilla.
	^ unRango.
! !
