TestCase subclass: #PlanillaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlanillaTests'!

!PlanillaTest methodsFor: 'tests' stamp: 'a 9/12/2019 17:41'!
testPlanillaPermiteColocarDatosEnCelda
	|unaPlanilla|
	unaPlanilla := Planilla new.
	unaPlanilla colocarEnCelda: 'C3' elValor: 5.
	self assert: (unaPlanilla getValorEnCelda: 'C3') equals: 5.
! !

!PlanillaTest methodsFor: 'tests' stamp: 'a 9/12/2019 17:42'!
testPlanillaPermiteColocarDatosNumericosEnCelda
	|unaPlanilla|
	unaPlanilla := Planilla new.
	unaPlanilla colocarEnCelda: 'C3' elValor: 5.
	self assert: (unaPlanilla getValorEnCelda: 'C3') equals: 5.
! !

!PlanillaTest methodsFor: 'tests' stamp: 'a 9/12/2019 17:39'!
testPlanillaVaciaNoTieneDatosEnLasCeldas
	|unaPlanilla|
	unaPlanilla := Planilla new.
	self assert: (unaPlanilla getValorEnCelda: 'A2') equals: ''.
! !

!PlanillaTest methodsFor: 'tests' stamp: 'a 9/12/2019 17:42'!
testPlanillaPermiteColocarDatosCadenaEnCelda
	|unaPlanilla|
	unaPlanilla := Planilla new.
	unaPlanilla colocarEnCelda: 'C3' elValor: '5'.
	self assert: (unaPlanilla getValorEnCelda: 'C3') equals: '5'.
! !


TestCase subclass: #RangosTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlanillaTests'!

!RangosTests methodsFor: 'tests' stamp: 'a 9/12/2019 18:28'!
testPuedoCrearRangoHorizontalVacio
	|unaPlanilla unRango|
	unaPlanilla := Planilla new.
	unRango := unaPlanilla crearRangoHorizontalDesde: 'A2' hasta: 'C2'.
	self assert: (unRango getCantidadCeldasUsadas = 0).
! !

!RangosTests methodsFor: 'tests' stamp: 'a 9/13/2019 16:11'!
testRangoSumaCeldasConNumeros
	|unaPlanilla unRango|
	unaPlanilla := Planilla new.
	unaPlanilla colocarEnCelda: 'B2' elValor: 'a'.
	unaPlanilla colocarEnCelda: 'A2' elValor: 4.
	unaPlanilla colocarEnCelda: 'C2' elValor: 1.	
	unRango := unaPlanilla crearRangoHorizontalDesde: 'A2' hasta: 'C2'.
	self assert: (unRango getSuma = 5).
! !

!RangosTests methodsFor: 'tests' stamp: 'a 9/13/2019 16:11'!
testRangoCuentaCeldasNoVacias
	|unaPlanilla unRango|
	unaPlanilla := Planilla new.
	unaPlanilla colocarEnCelda: 'B2' elValor: 'a'.
	unRango := unaPlanilla crearRangoHorizontalDesde: 'A2' hasta: 'C2'.
	self assert: (unRango getCantidadCeldasUsadas = 1).
! !


TestCase subclass: #UbicacionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlanillaTests'!

!UbicacionTests methodsFor: 'tests' stamp: 'a 9/13/2019 15:01'!
testUbicacionDevuelveSuCoordenada
	| unaUbicacion |
	unaUbicacion := Ubicacion con: 'C4'.
	self assert: (unaUbicacion coordenada) equals: 'C4'.! !
